package com.jiuqi.util.tree;

import java.util.Stack;
import java.util.Iterator;

class TreeIterator implements Iterator
{
    private Stack stack;
    
    public TreeIterator(final TreeNode root) {
        (this.stack = new Stack()).push(new NodeStub(root, 0));
    }
    
    public boolean hasNext() {
        while (!this.stack.empty()) {
            final NodeStub prev = this.stack.peek();
            if (prev.next < prev.node.size()) {
                return true;
            }
            this.stack.pop();
        }
        return false;
    }
    
    public Object next() {
        while (!this.stack.empty()) {
            final NodeStub prev = this.stack.peek();
            if (prev.next < prev.node.size()) {
                final TreeNode nextNode = prev.node.get(prev.next);
                if (nextNode.size() > 0) {
                    this.stack.push(new NodeStub(nextNode, 0));
                }
                final NodeStub nodeStub = prev;
                ++nodeStub.next;
                return nextNode.getItem();
            }
            this.stack.pop();
        }
        return null;
    }
    
    public void remove() {
        throw new UnsupportedOperationException("树形枚举器不支持删除操作！");
    }
    
    private static class NodeStub
    {
        public TreeNode node;
        public int next;
        
        public NodeStub(final TreeNode node, final int next) {
            this.node = null;
            this.next = 0;
            this.node = node;
            this.next = next;
        }
    }
}
